# spacestudio-orbit-propagation
<b>CHANGELOG</b>
<ul>
  <li><b>1.3.0</b> - 2024-07-03 - Add <b>atmosphericModel</b> and NRLMSISE00-related fields in <b>DragPerturbation</b> schema</li>
  <li><b>1.2.0</b> - 2024-06-13 - Add <b>missionDuration</b> field in response payload</li>
  <li><b>1.1.5</b> - 2024-06-06 - Improve API documentation</li>
  <li><b>1.1.4</b> - 2024-05-28 - Improve API documentation</li>
  <li><b>1.1.3</b> - 2024-05-28 - Improve API documentation</li>
  <li><b>1.1.2</b> - 2024-05-28 - Improve API documentation</li>
  <li><b>1.1.1</b> - 2024-05-28 - Delete <i>NONE</i> solar array type</li>
  <li><b>1.1.0</b> - 2024-05-28 - Add perturbations and refactor API</li>
  <li><b>1.0.0</b> - 2024-05-27 - Initial version</li>
</ul>


This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.3.1
- Package version: 1.3.1
- Generator version: 7.8.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import spacestudio_orbit_propagation
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import spacestudio_orbit_propagation
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import spacestudio_orbit_propagation
from spacestudio_orbit_propagation.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://spacestudio-orbit-propagation.exoops.37.59.31.223.sslip.io
# See configuration.py for a list of all supported configuration parameters.
configuration = spacestudio_orbit_propagation.Configuration(
    host = "http://spacestudio-orbit-propagation.exoops.37.59.31.223.sslip.io"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization: BearerAuth
configuration = spacestudio_orbit_propagation.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with spacestudio_orbit_propagation.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = spacestudio_orbit_propagation.DefaultApi(api_client)
    orbit_propagation_request = {"inputs":{"duration":864000,"propagationType":"NUMERICAL","targetDateDefinitionType":"DURATION","initialOrbit":{"sso":false,"inclination":0.5,"sma":"61.3.1","eccentricity":0,"parameters":{"parametersType":"CIRCULAR_ALTITUDE","altitude":"61.3.1"}},"platform":{"mass":112}},"outputs":{"ephemerides":["KEPLERIAN"],"ephemeridesStep":3600,"meanEphemerides":true,"osculatingEphemerides":false}} # OrbitPropagationRequest |  (optional)

    try:
        # Orbit propagation computation
        api_response = api_instance.compute_orbit_propagation(orbit_propagation_request=orbit_propagation_request)
        print("The response of DefaultApi->compute_orbit_propagation:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DefaultApi->compute_orbit_propagation: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://spacestudio-orbit-propagation.exoops.37.59.31.223.sslip.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**compute_orbit_propagation**](docs/DefaultApi.md#compute_orbit_propagation) | **POST** / | Orbit propagation computation


## Documentation For Models

 - [AdvancedOrbitParameters](docs/AdvancedOrbitParameters.md)
 - [AtmosphericModel](docs/AtmosphericModel.md)
 - [Axis](docs/Axis.md)
 - [BodySolarArray](docs/BodySolarArray.md)
 - [BoxSpacecraftGeometry](docs/BoxSpacecraftGeometry.md)
 - [CartesianEphemerides](docs/CartesianEphemerides.md)
 - [CircularAltitudeOrbitParameters](docs/CircularAltitudeOrbitParameters.md)
 - [CircularGroundTrackRepeatedOrbitParameters](docs/CircularGroundTrackRepeatedOrbitParameters.md)
 - [DeployableFixedSolarArray](docs/DeployableFixedSolarArray.md)
 - [DeployableRotatingSolarArray](docs/DeployableRotatingSolarArray.md)
 - [DragPerturbation](docs/DragPerturbation.md)
 - [EarthPotentialPerturbation](docs/EarthPotentialPerturbation.md)
 - [EllipticalGroundTrackRepeatedEccentricityOrbitParameters](docs/EllipticalGroundTrackRepeatedEccentricityOrbitParameters.md)
 - [EllipticalPerigeeAltApogeeAltOrbitParameters](docs/EllipticalPerigeeAltApogeeAltOrbitParameters.md)
 - [EllipticalPerigeeAltEccentricityOrbitParameters](docs/EllipticalPerigeeAltEccentricityOrbitParameters.md)
 - [EllipticalSmaEccentricityOrbitParameters](docs/EllipticalSmaEccentricityOrbitParameters.md)
 - [EphemerisType](docs/EphemerisType.md)
 - [HarrisPriesterAtmosphericModel](docs/HarrisPriesterAtmosphericModel.md)
 - [KeplerianEphemerides](docs/KeplerianEphemerides.md)
 - [MeanOrOsculatingSpacecraftStates](docs/MeanOrOsculatingSpacecraftStates.md)
 - [MeanOrOsculatingSpacecraftStatesAttitude](docs/MeanOrOsculatingSpacecraftStatesAttitude.md)
 - [MeanOrOsculatingSpacecraftStatesPvCoordinates](docs/MeanOrOsculatingSpacecraftStatesPvCoordinates.md)
 - [NRLMSISE00AtmosphericModel](docs/NRLMSISE00AtmosphericModel.md)
 - [Orbit](docs/Orbit.md)
 - [OrbitParameters](docs/OrbitParameters.md)
 - [OrbitPropagationRequest](docs/OrbitPropagationRequest.md)
 - [OrbitPropagationRequestInputs](docs/OrbitPropagationRequestInputs.md)
 - [OrbitPropagationRequestOutputs](docs/OrbitPropagationRequestOutputs.md)
 - [OrbitPropagationRequestOutputsOrbitalEphemerides](docs/OrbitPropagationRequestOutputsOrbitalEphemerides.md)
 - [OrbitPropagationRequestOutputsSpacecraftStates](docs/OrbitPropagationRequestOutputsSpacecraftStates.md)
 - [OrbitPropagationResult](docs/OrbitPropagationResult.md)
 - [OrbitPropagationResultFieldIndexesInner](docs/OrbitPropagationResultFieldIndexesInner.md)
 - [OrbitPropagationResultOrbitalEphemerides](docs/OrbitPropagationResultOrbitalEphemerides.md)
 - [OrbitPropagationResultOrbitalEphemeridesMean](docs/OrbitPropagationResultOrbitalEphemeridesMean.md)
 - [OrbitPropagationResultOrbitalEphemeridesOsculating](docs/OrbitPropagationResultOrbitalEphemeridesOsculating.md)
 - [OrbitPropagationResultSpacecraftStates](docs/OrbitPropagationResultSpacecraftStates.md)
 - [Perturbation](docs/Perturbation.md)
 - [Platform](docs/Platform.md)
 - [SolarArray](docs/SolarArray.md)
 - [SolarArrayFace](docs/SolarArrayFace.md)
 - [SpacecraftGeometry](docs/SpacecraftGeometry.md)
 - [SpacecraftGeometryDimension](docs/SpacecraftGeometryDimension.md)
 - [SphericalSpacecraftGeometry](docs/SphericalSpacecraftGeometry.md)
 - [SrpPerturbation](docs/SrpPerturbation.md)
 - [ThirdBodyPerturbation](docs/ThirdBodyPerturbation.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="BearerAuth"></a>
### BearerAuth

- **Type**: Bearer authentication


## Author




